// This file is released under the 3-clause BSD license. See COPYING-BSD.

// This macro compiles the files

function builder_c()

path = pwd();
src_c_path = get_absolute_file_path("builder_c.sce");

cd (src_c_path);
ilib_name = 'libchecka'		// interface library name
files=['check.c' 'ccheck.c' 'checka.c' 'input.c' 'forward.c' 'datastru.c' 'debug.c' 'lib.c'];
libs=[];

CFLAGS = ["-I" + src_c_path];

table =["check","intscheck"];

if getos() == 'Windows'
    ilib_build(ilib_name,table,files,libs);
else
    ilib_build(ilib_name,table,files,libs,[],[],CFLAGS);
end


ilib_name = 'libhyon'		// interface library name
files=['hyon.c' 'chyontrain.c' 'hyonline.c' 'input.c' 'forward.c' 'LSE_kalman.c' 'backward.c' 'stepsize.c' 'de_dp.c' 'trn_err.c' 'new_para.c' 'datastru.c' 'lib.c' 'output.c' ];
libs=[];
table =["hyontrain","intshyontrain"];
if getos() == 'Windows'
    ilib_build(ilib_name,table,files,libs);
else
    ilib_build(ilib_name,table,files,libs,[],[],CFLAGS);
end


ilib_name = 'libhysci'		// interface library name
files=['hysci.c' 'chytrain.c' 'hybrid.c' 'input.c' 'forward.c' 'kalman.c' 'backward.c' 'stepsize.c' 'de_dp.c' 'trn_err.c' 'new_para.c' 'chk_err.c' 'datastru.c' 'debug.c' 'lib.c' 'output.c' ];
libs=[];
table =["hytrain","intshytrain"];
if getos() == 'Windows'
    ilib_build(ilib_name,table,files,libs);
else
    ilib_build(ilib_name,table,files,libs,[],[],CFLAGS);
end


cd(path);
//  src_c_path = get_absolute_file_path("builder_c.sce");
//
//  CFLAGS = ilib_include_flag(src_c_path);
//  
//  files=[ 'check.c' 'ccheck.c' 'checka.c' 'input.c' 'forward.c' 'datastru.c' 'debug.c' 'lib.c'];
//  names=[ 'check' 'ccheck' 'checka' 'input' 'forward' 'datastru' 'debug' 'lib'];
//  tbx_build_src(names,       ..
//                files, ..
//                "c",                ..
//                src_c_path,         ..
//                "",                 ..
//                "",                 ..
//                CFLAGS,..
//                "",..
//                "",..
//                "libchecka");
//
//  files=['hyon.c' 'chyontrain.c' 'hyonline.c' 'input.c' 'forward.c' 'LSE_kalman.c' ..
//         'backward.c' 'stepsize.c' 'de_dp.c' 'trn_err.c' 'new_para.c' 'datastru.c' 'lib.c' 'output.c' ];  
//  names=['hyon' 'chyontrain' 'hyonline' 'input' 'forward' 'LSE_kalman' ..
//         'backward' 'stepsize' 'de_dp' 'trn_err' 'new_para' 'datastru' 'lib' 'output' ];
//         
//  tbx_build_src(names,       ..
//                files, ..
//                "c",                ..
//                src_c_path,         ..
//                "",                 ..
//                "",                 ..
//                CFLAGS,..
//                "",..
//                "",..
//                "libhyon");
//                
//  files=['hysci.c' 'chytrain.c' 'hybrid.c' 'input.c' 'forward.c' 'kalman.c' 'backward.c'..
//         'stepsize.c' 'de_dp.c' 'trn_err.c' 'new_para.c' 'chk_err.c' 'datastru.c' 'debug.c' 'lib.c' 'output.c' ];
//  names=['hysci' 'chytrain' 'hybrid' 'input' 'forward' 'kalman' 'backward'..
//         'stepsize' 'de_dp' 'trn_err' 'new_para' 'chk_err' 'datastru' 'debug' 'lib' 'output' ];
//  tbx_build_src(names,       ..
//                files, ..
//                "c",                ..
//                src_c_path,         ..
//                "",                 ..
//                "",                 ..
//                CFLAGS,..
//                "",..
//                "",..
//                "libhysci");                
        
                
endfunction

builder_c();
clear builder_c; // remove builder_c on stack

