/*
   ANFISLAB: Toolbox de ANFIS (ADAPTATIVE-NETWORK-BASED-FUZZY INFERENCE SYSTEM) para SCILAB
   Creado Por Andres G. Avendao Cabezas., Universidad Central de Venezuela (andrewg.avendano@gmail.com),
  Agosto de 2009, con adaptaciones del codigo ANFIS de dominio publico de Jyh-shing Roger Jang
  (http://www.cs.nthu.edu.tw/~jang/publication.htm).
   Este programa fue probado en SCILAB version 5.1.1, PC Intel Core(TM) Duo 2,1Ghz, corriendo Linux 2.6.27.7
*/

//#include "/home/andrew1/scilab-5.1.1.bin.linux-i686/scilab-5.1.1/include/scilab/core/machine.h"
#include "machine.h"
#include "anfis.h"
#include "misc_def.h"

NODE_T **node_p;
int In_n, Mf_n, Rule_n, Node_n, funper;
void F2C(ccheck)(int *k, int *L, int *pchk, int *Fp, double *abcin, int *ma, int *na, double *pqrin, int *mb, int *nb, double *checking_data_pointer, int *md, double *anfis_output)
{
   int i,j,s;
   int checking_data_n;
   double **abc, **pqr;
   double **checking_data_matrix;
   In_n=*k;
   Mf_n=*L;
   checking_data_n=*pchk;
   funper=*Fp;

	abc = (double **)create_matrix
			(*ma, *na, sizeof(double));
	pqr = (double **)create_matrix
			(*mb, *nb, sizeof(double));
	checking_data_matrix = (double **)create_matrix
			(*pchk, *k + 1, sizeof(double));

s=0;j=0;
for ( i =0 ; i < (*na)*(*ma) ; i++){
         abc[s][j] = abcin[i];
         s=s++;
         if (s > *ma-1){
         s=0;j=j++;
         }
   }
s=0;j=0;
for ( i =0 ; i < (*mb)*(*nb) ; i++){
         pqr[s][j] = pqrin[i];
         s=s++;
         if (s > *mb-1)
         {
         s=0;j=j++;
         }
   }

s=0;j=0;
for ( i =0 ; i < checking_data_n*(In_n+1) ; i++){
         checking_data_matrix[s][j] = checking_data_pointer[i]; 
         s=s++;
         if (s > *md-1){
         s=0;j=j++;
         }
   }

checka(In_n, Mf_n, checking_data_n, funper, abc, pqr, checking_data_matrix, anfis_output);
}
