/*
   Copyright (c) 1991 Jyh-Shing Roger Jang, Dept of EECS, U.C. Berkeley
   BISC (Berkeley Initiative on Soft Computing) group
   jang@eecs.berkeley.edu
   Permission is granted to modify and re-distribute this code in any manner
   as long as this notice is preserved.  All standard disclaimers apply.
*/

/*
   ANFISLAB: Toolbox de ANFIS (ADAPTATIVE-NETWORK-BASED-FUZZY INFERENCE SYSTEM) para SCILAB
   Creado Por Andres G. Avendao Cabezas., Universidad Central de Venezuela (andrewg.avendano@gmail.com),
  Agosto de 2009, con adaptaciones del codigo ANFIS de dominio publico de Jyh-shing Roger Jang
  (http://www.cs.nthu.edu.tw/~jang/publication.htm).
   Este programa fue probado en SCILAB version 5.1.1, PC Intel Core(TM) Duo 2,1Ghz, corriendo Linux 2.6.27.7 y Windows Xp sp2.
*/

#define __USE_DEPRECATED_STACK_FUNCTIONS__
#include "anfis.h"
#include <sciprint.h>
#include <stack-c.h>
#include "misc_def.h"

NODE_T **node_p;
int In_n, Mf_n, Rule_n, Node_n, funper;
void
   checka(In_n, Mf_n, checking_data_n, funper, abc, pqr, checking_data_matrix, anfis_output)
	int checking_data_n;
	double **abc, **pqr;
	double **checking_data_matrix;
	double *anfis_output;
{
	int i, j, k;
   	double **checking_data_pointer;
	double desired_output;
	Rule_n = (int)pow((double)Mf_n, (double)In_n);
	Node_n = In_n + In_n*Mf_n + 3*Rule_n + 1;

	node_p = (NODE_T **)create_array(Node_n, sizeof(NODE_T *));
	checking_data_pointer = (double **)create_matrix
			(checking_data_n, In_n + 1, sizeof(double));

	get_config();
	build_anfis();
	get_parameter(abc,pqr);
	//sciprint("printing a double:   %f\n", pqr);
   	get_data(checking_data_matrix, checking_data_n, checking_data_pointer);
	//printf("Data_n\t Salida ANFIS \t Salida deseada\n");
	//printf("------\t ------------ \t --------------\n");
	//sciprint("Data_n\t Salida ANFIS \t Salida deseada\n");
	//sciprint("------\t ------------ \t --------------\n");
	for (j = 0; j < checking_data_n; j++) {
		put_input_data(j, checking_data_pointer);
		calculate_output(In_n, Node_n - 1); 
		anfis_output[j] = node_p[Node_n - 1]->value;
		desired_output = checking_data_pointer[j][In_n];
//printf("%3d \t %lf \t %lf\n", j+1,anfis_output[j],desired_output);
//sciprint("%3d \t %lf \t %lf\n", j+1,anfis_output[j],desired_output);
	}
}
