/*
   ANFISLAB: Toolbox de ANFIS (ADAPTATIVE-NETWORK-BASED-FUZZY INFERENCE SYSTEM) para SCILAB
   Creado Por Andres G. Avendao Cabezas., Universidad Central de Venezuela (andrewg.avendano@gmail.com),
  Agosto de 2009, con adaptaciones del codigo ANFIS de dominio publico de Jyh-shing Roger Jang
  (http://www.cs.nthu.edu.tw/~jang/publication.htm).
   Este programa fue probado en SCILAB version 5.1.1, PC Intel Core(TM) Duo 2,1Ghz, corriendo Linux 2.6.27.7
*/

#include "machine.h"
#include "anfis.h"
#include "misc_def.h"
NODE_T **node_p;
int In_n, Mf_n, Rule_n, Node_n, funper;
double **abc, **pqr, **training_data_matrix;
void F2C(chyontrain)(int *k, int *L, int *pin, int *Fp, double *ka, double *abcin, int *ma, int *na, double *pqrin, int *mb, int *nb, double *training_data_pointer, int *mc, double *trn_evol_error)
{
   int i,j,s;
   int training_data_n;
   double step_size;
   double **trn_evol;
   In_n=*k;
   Mf_n=*L;
   training_data_n=*pin;
   funper=*Fp;
   step_size=*ka;
printf("In_n %3d \t Mf_n %3d \t training_data_n %3d \t funper %3d \t step_size %3f\n", In_n, Mf_n, training_data_n, funper, step_size);

	abc = (double **)create_matrix
			(*ma, *na, sizeof(double));
	pqr = (double **)create_matrix
			(*mb, *k + 1, sizeof(double));
	training_data_matrix = (double **)create_matrix
			(*pin, *k + 1, sizeof(double));
	trn_evol = (double **)create_matrix
			(*pin, *na, sizeof(double));

s=0;j=0;
for ( i =0 ; i < (*na)*(*ma) ; i++){
         abc[s][j] = abcin[i];
         s=s++;
         if (s > *ma-1){
         s=0;j=j++;
         }
   }

s=0;j=0;
for ( i =0 ; i < (*mb)*(*nb) ; i++){
         pqr[s][j] = pqrin[i];
         s=s++;
         if (s > *mb-1)
         {
         s=0;j=j++;
         }
   }

s=0;j=0;
for ( i =0 ; i < (*mc)*(*nb) ; i++){
         training_data_matrix[s][j] = training_data_pointer[i]; 
         s=s++;
         if (s > *mc-1){
         s=0;j=j++;
         }
   }

hyonline(In_n, Mf_n, training_data_n, funper, step_size, abc, pqr, training_data_matrix, trn_evol);
printf("Paso 1 \n");
s=0;j=0;
for ( i =0 ; i < (*na)*(*ma) ; i++){
         abcin[i] = abc[s][j];
         s=s++;
         if (s > *ma-1){
         s=0;j=j++;
         }
   }
printf("Paso 2 \n");
s=0;j=0;
for ( i =0 ; i < (*mb)*(*nb) ; i++){
         pqrin[i] = pqr[s][j]; 
         s=s++;
         if (s > *mb-1){
         s=0;j=j++;
         }
   }
printf("Paso 3 \n");
s=0;j=0;
for ( i =0 ; i < (*mc)*(*nb); i++) {
         trn_evol_error[i] = trn_evol[s][j]; 
         s=s++;
         if (s > *mc-1){
         s=0;j=j++;
         }
   }
printf("Paso 4 \n");
}
