/*
   Copyright (c) 1991 Jyh-Shing Roger Jang, Dept of EECS, U.C. Berkeley
   BISC (Berkeley Initiative on Soft Computing) group
   jang@eecs.berkeley.edu
   Permission is granted to modify and re-distribute this code in any manner
   as long as this notice is preserved.  All standard disclaimers apply.
*/

/*
   ANFISLAB: Toolbox de ANFIS (ADAPTATIVE-NETWORK-BASED-FUZZY INFERENCE SYSTEM) para SCILAB
   Creado Por Andres G. Avendao Cabezas., Universidad Central de Venezuela (andrewg.avendano@gmail.com),
  Agosto de 2009, con adaptaciones del codigo ANFIS de dominio publico de Jyh-shing Roger Jang
  (http://www.cs.nthu.edu.tw/~jang/publication.htm).
   Este programa fue probado en SCILAB version 5.1.1, PC Intel Core(TM) Duo 2,1Ghz, corriendo Linux 2.6.27.7 y Windows Xp sp2.
*/

#define __USE_DEPRECATED_STACK_FUNCTIONS__
#include "anfis.h"
#include <sciprint.h>
#include <stack-c.h>

/* get parameters from abc & pqr */
void
get_parameter(abc,pqr)
double **abc, **pqr;
{
	int i, j, k,ka;
	int parameter_n;
	double tmp;
	PARAMETER_LIST_T *p;
j=0;ka=0;
	for (i = 0; i < Node_n; i++) {
		if (node_p[i]->parameter == NULL)
			continue;
		parameter_n = node_p[i]->parameter_n;
		p = node_p[i]->parameter;

   if (j < In_n*Mf_n) 
   {
   		for (k = 0; k < 3; k++) 
			{
         tmp=abc[j][k];
   		p->content = tmp;
			p = p->next;
			}
   j=j++;
   }
   else if (j >= In_n*Mf_n) 
      {
   		for (k = 0; k < (In_n+1); k++) 
			{
         tmp=pqr[j-In_n*Mf_n][k];
   		p->content = tmp;
		//sciprint("printing a double:   %f\n", tmp);
ka=ka++;
			p = p->next;
			}
   j=j++;
   }
	}
}
/* modificado*/
void
get_data(data_matrix, data_n, data_pointer)
int data_n;
double **data_matrix, **data_pointer; 
{
	int i, j;
	double tmp;

	if (data_n == 0)
		return;
	for (i = 0; i < data_n; i++)
		for (j = 0; j < In_n + 1; j++)
			{
            tmp = data_matrix[i][j];
				data_pointer[i][j] = tmp;
				//sciprint("printing a double:   %f\n", tmp);
	      }

		
}

/* put input part of (j+1)-th data (training or checking) to input nodes. */
void
put_input_data(j, data_pointer)
int j;
double **data_pointer;
{
	int k;
	for (k = 0; k < In_n; k++)
      {
		node_p[k]->value = data_pointer[j][k];
      }
}
