/*
   Copyright (c) 1991 Jyh-Shing Roger Jang, Dept of EECS, U.C. Berkeley
   BISC (Berkeley Initiative on Soft Computing) group
   jang@eecs.berkeley.edu
   Permission is granted to modify and re-distribute this code in any manner
   as long as this notice is preserved.  All standard disclaimers apply.
*/

/*
   ANFISLAB: Toolbox de ANFIS (ADAPTATIVE-NETWORK-BASED-FUZZY INFERENCE SYSTEM) para SCILAB
   Creado Por Andres G. Avendao Cabezas., Universidad Central de Venezuela (andrewg.avendano@gmail.com),
  Agosto de 2009, con adaptaciones del codigo ANFIS de dominio publico de Jyh-shing Roger Jang
  (http://www.cs.nthu.edu.tw/~jang/publication.htm).
   Este programa fue probado en SCILAB version 5.1.1, PC Intel Core(TM) Duo 2,1Ghz, corriendo Linux 2.6.27.7
*/

#include "anfis.h"

/* write parameters to file 'file_name' */
void
write_parameter(abc,pqr)
double **abc, **pqr;
{
	int i, j, k, ka;
	double tmp;
	PARAMETER_LIST_T *p;
j=0;k=0;ka=0;
	for (i = 0; i < Node_n; i++) {
		if (node_p[i]->parameter == NULL)
			continue;
		for (p = node_p[i]->parameter; p != NULL; p = p->next) {
         if (j < In_n*Mf_n) 
            {
            tmp=p->content;
            abc[j][k]=tmp;
         k=k++;
            if (k>2){
            j=j++;
            k=0;
            }
         }
         else if (j >= In_n*Mf_n)    
            {
            tmp=p->content;
            pqr[j-In_n*Mf_n][k]=tmp;
         k=k++;
            if (k>(In_n)){
            j=j++;
            k=0;
            }
         }
         }
	}

}

/* record the current parameters in an array */
void
record_parameter(parameter_array)
double *parameter_array;
{
	int i, j = 0;
	PARAMETER_LIST_T *p;

	for (i = 0; i < Node_n; i++) {
		if (node_p[i]->parameter == NULL)
			continue;
		for (p = node_p[i]->parameter; p != NULL; p = p->next) 
			parameter_array[j++] = p->content;
	}
}

/* restore the parameter in parameter_array back to ANFIS */
void
restore_parameter(parameter_array)
double *parameter_array;
{
	int i, j = 0;
	PARAMETER_LIST_T *p;

	for (i = 0; i < Node_n; i++) {
		if (node_p[i]->parameter == NULL)
			continue;
		for (p = node_p[i]->parameter; p != NULL; p = p->next) 
			p->content = parameter_array[j++];
	}
}
